diff --git a/apps/app_queue.c b/apps/app_queue.c
index 013a5fc..c907211 100644
--- a/apps/app_queue.c
+++ b/apps/app_queue.c
@@ -2822,7 +2822,8 @@ static int try_calling(struct queue_ent *qe, const char *options, char *announce
 	int callcompletedinsl;
 	struct ao2_iterator memi;
 	struct ast_datastore *datastore, *transfer_ds;
-
+	int need_weight = 0;
+	
 	ast_channel_lock(qe->chan);
 	datastore = ast_channel_datastore_find(qe->chan, &dialed_interface_info, NULL);
 	ast_channel_unlock(qe->chan);
@@ -2875,7 +2876,8 @@ static int try_calling(struct queue_ent *qe, const char *options, char *announce
 		}
 
 	/* Hold the lock while we setup the outgoing calls */
-	if (use_weight)
+	need_weight = use_weight;
+	if (need_weight)
 		AST_LIST_LOCK(&queues);
 	ao2_lock(qe->parent);
 	if (option_debug)
@@ -2896,7 +2898,7 @@ static int try_calling(struct queue_ent *qe, const char *options, char *announce
 			ao2_iterator_destroy(&memi);
 			ao2_ref(cur, -1);
 			ao2_unlock(qe->parent);
-			if (use_weight)
+			if (need_weight)
 				AST_LIST_UNLOCK(&queues);
 			goto out;
 		}
@@ -2905,7 +2907,7 @@ static int try_calling(struct queue_ent *qe, const char *options, char *announce
 				ao2_iterator_destroy(&memi);
 				ao2_ref(cur, -1);
 				ao2_unlock(qe->parent);
-				if (use_weight)
+				if (need_weight)
 					AST_LIST_UNLOCK(&queues);
 				free(tmp);
 				goto out;
@@ -2915,7 +2917,7 @@ static int try_calling(struct queue_ent *qe, const char *options, char *announce
 				ao2_iterator_destroy(&memi);
 				ao2_ref(cur, -1);
 				ao2_unlock(qe->parent);
-				if (use_weight)
+				if (need_weight)
 					AST_LIST_UNLOCK(&queues);
 				free(tmp);
 				goto out;
@@ -2953,7 +2955,7 @@ static int try_calling(struct queue_ent *qe, const char *options, char *announce
 				ao2_iterator_destroy(&memi);
 				ao2_ref(cur, -1);
 				ao2_unlock(qe->parent);
-				if (use_weight)
+				if (need_weight)
 					AST_LIST_UNLOCK(&queues);
 				free(tmp);
 				goto out;
@@ -2994,7 +2996,7 @@ static int try_calling(struct queue_ent *qe, const char *options, char *announce
 	++qe->pending;
 	ao2_unlock(qe->parent);
 	ring_one(qe, outgoing, &numbusies);
-	if (use_weight)
+	if (need_weight)
 		AST_LIST_UNLOCK(&queues);
 	lpeer = wait_for_answer(qe, outgoing, &to, &digit, numbusies, ast_test_flag(&(bridge_config.features_caller), AST_FEATURE_DISCONNECT), forwardsallowed);
 	/* The ast_channel_datastore_remove() function could fail here if the
